﻿/*
preflight_check.jsx
(c)2011 seuzo.jp
ドキュメントを開いた後、プリントする前、書出し前、保存する前に指定したプロファイルでプリフライトチェックをします。
15行目あたりにあるmy_profile_nameにチェックしたいプロファイル名を記入してください

2011-09-11  ver 0.1 とりあえず
*/

#target "InDesign"
#targetengine "preflight_check"

(function(){
//////////////設定
var my_profile_name = "[基本]"; //使用するプリフライトのプロファイル名
var my_profile_name = "seuzo-preflight"; //使用するプリフライトのプロファイル名

function check_preflight(my_event){
    if (app.documents.length === 0){return;}
    if ((parseInt(app.version) >= 7) &&
        (my_event.eventType === "afterOpen") &&
        (my_event.target instanceof LayoutWindow)){
        return;
    }
    var my_doc = app.documents[0];    
    
    ////preflightProfileオブジェクトに変換
    if ((/^\[?(基本|Basic)\]?$/i).test(my_profile_name)) {
        var my_profile = app.preflightProfiles.item[0];//[基本]プロファイルは名前参照できないみたい
    } else {
          ////入力されたmy_profile_nameの名前が存在しているかどうか
         var tmp_str = "[";//すべてのプロファイルを繋げた文字列
         for (var i = 0; i < app.preflightProfiles.length; i++) {
             tmp_str += app.preflightProfiles[i].name + "][";
          }
        if (tmp_str.indexOf(my_profile_name) === -1) {
              alert("「" + my_profile_name + "」プロファイルは存在しません"); 
              return;
         }
        var my_profile = app.preflightProfiles.itemByName(my_profile_name);
    }
    
    /////プリフライトチェックを実行
    var my_process = app.preflightProcesses.add(my_doc, my_profile);
    my_process.waitForProcess();
    var my_results = my_process.processResults;//返事
    my_process.remove();//プロセスをクリーンアップする
    //$.writeln(my_results);

    
    ////エラーがあれば警告ダイアログを出す
    //プリフライトでOKが出ると"None\r\n"が返る（CS5）
    if ((my_results.length < 7) && (/^None/i).test(my_results)) {
        return;
    } else {
        alert("プリフライトエラーです\rプロファイル名：" + my_profile_name);
    }

}//function check_preflight

    app.addEventListener("afterOpen", check_preflight, false);//ドキュメントを開いた後
    app.addEventListener("beforeExport", check_preflight, false);//書出し前
    app.addEventListener("beforePrint", check_preflight, false);//プリント前
    app.addEventListener("beforeSave", check_preflight, false);//保存前
})();